﻿using Bizgaze.CRM;
using Bizgaze.CRM.Visitors.Infos;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;
using Unibase.Data;
using Unibase.Data.Expressions;
using Unibase.Data.Sql;
using Unibase.Dependency;
using Unibase.Platform.Apps.Managers;
using Unibase.Platform.Data;
using Unibase.Platform.Forms.Providers;
using Unibase.Platform.Keys;

namespace CRM.Visitors.ActionProviders
{
    class FeedBackPostActionProvider : BaseFormActionProvider, IFormActionProvider
    {
        public string ControllerClass
        {
            get
            {
                return "Bizgaze.CRM.Visitors.ActionProviders.FeedBackPostActionProvider";

            }
        }
        public string FormActionName
        {
            get
            {
                return "FeedBack";
            }
        }
        public string Description
        {
            get
            {
                return "Feed Back Pos tAction Provider";
            }
        }
        public UniqueKey UniqueId
        {
            get
            {
                return Bizgaze.CRM.Actions.FeedBack;
            }
        }
        public int ActionType
        {
            get
            {
                return (int)Unibase.Platform.Forms.Enums.FormActionProvider.PostAction;
            }
        }
        
        public async Task<ActionResponse<FormActionResponse>> ExecuteAsync(ActionRequest request, FormActionProviderObject providerObject)
        {
            using (var requestTrans = await request.BeginTransactionAsync())
            {
                var IdValue = providerObject.IdValue;
                var srequest = SelectRequest.FromRequest(request);
                var obj = providerObject.RequestObject;
                var docParametersList = providerObject.DocParametersList;
                dynamic visitorparam = new Dictionary<string, object>();
                var defaultPKValue = providerObject.DefaultPKValue;
                var stageManager = Unibase.Dependency.DependencyConfig.Resolve<IStageManager>();
                var visitorManager = Unibase.Dependency.DependencyConfig.Resolve<Bizgaze.CRM.Visitors.Managers.IVisitorManager>();
                var dictObj = obj as IDictionary<string, dynamic>;
                var connection = GetConnection(request);
               List<Unibase.Platform.Forms.Requests.DocParameter> docParameters = dictObj["DocParameters"];
                var updateinfo = docParameters.Find(y => y.DocType == "bizgazecrm_visitors");
                var visitorid = updateinfo.Parameters["visitorid"];
                var date = DateTime.Now;
                var UpdateStage = new Update("bizgazecrm_visitors").Value("lastupdateddate", date).Where(Exp.Eq("visitorid", visitorid));
                 await _repository.ExecuteAsync(request, UpdateStage);
                var checkinfo = docParameters.Find(x => x.DocType == "bizgazecrm_visitorcheckout");
                var returnresponse = new FormActionResponse();
                returnresponse.Obj = null;
                returnresponse.PkValue = 0;
                return ActionResponse<FormActionResponse>.CreateSuccessResponse("success", returnresponse);
            }
        }
        public List<UniqueKey> AppliedApps
        {
            get
            {
                return new List<UniqueKey>() {
                    Bizgaze.CRM.Actions.FeedBack,
            };
            }
        }
    }
}
